
import java.io.File;
import java.io.IOException;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiUnavailableException;

import database.DbUsers;
import database.TableUsers;

import sdljava.SDLException;
import sdljava.video.SDLSurface;

public class Login {
	
	private Text textArial15;
	
	private	boolean end;

	private CFrame[] framepopups;
	
	private CSprite spritepopup;
	private String title;
	
	private CFrame framebutton;
	private CSprite spritebutton;
	private Keyboard keyboard;

	private int option;

	private String username;
	private String userpass;
	private int usernamepass;
	DbUsers dbusers; 
	Event event;
	
	public Login(){
		
		event = new Event();
		
        dbusers = new DbUsers();
		try{
			 textArial15 = new Text();
			    textArial15.init("fonts"+  File.separator + "arial.ttf",15);
			    textArial15.setcolor(0, 0,0);
		}
		catch(Exception e){
			
			
		}
		
		this.username = "";
		this.userpass = "";
		
		this.usernamepass = 1;

		this.title  ="";
		this.option = 1;
		
		this.keyboard = new Keyboard();
		 
		this.end = false;
		
		this.framebutton = new CFrame();
		
		this.spritebutton = new CSprite();
		
		String dir = "";
		this.spritepopup = new CSprite();
		this.framepopups = new CFrame[8];
		try{
			for (int i=0;i<=7;i++ ) {
				
				framepopups[i] = new CFrame();
				dir = "sprites"+  File.separator +"popup" + File.separator +"popup"+i+".png";
				System.out.println(dir);
				framepopups[i].load(dir);
				
				spritepopup.addframe(framepopups[i]);
			}
			
		}
		catch(Exception e){
			
		}
		
	    try{
	    	this.framebutton.load("sprites"+  File.separator + "popupbutton.png");
	    	
			
				this.spritebutton.addframe(framebutton);
			
	    	
	    	//this.framepopup.load("sprites"+  File.separator + "popup.png");
	    	//this.spritepopup.addframe(framepopup);
	    }
	    catch(Exception e){
	    	System.out.println("Error Popup() " + e);
	    }
	}
	public void draw(SDLSurface screen){
		
		
		try{
	
			//System.out.println(this.spritepopup.getnumframes());
			this.spritepopup.setx(200);
			this.spritepopup.sety(200);
			this.spritepopup.draw(screen);
			
			this.textArial15.drawtext(this.title, screen,230,210);
				
			this.textArial15.drawtext("Usuario : " , screen,this.spritepopup.getx()+20,this.spritepopup.gety()+50);
			this.textArial15.drawtext("Contraseña : " , screen,this.spritepopup.getx()+20,this.spritepopup.gety()+100);

			this.textArial15.drawtext(" " + this.username, screen,this.spritepopup.getx()+50,this.spritepopup.gety()+80);
			
			String userpasscod =" ";
			for (int i=0;i<this.userpass.length();i++){
				userpasscod = userpasscod + "*";
			}
			this.textArial15.drawtext( userpasscod, screen,this.spritepopup.getx()+50,this.spritepopup.gety()+125);


			this.spritebutton.setx(this.spritepopup.getx() + 120);
			this.spritebutton.sety(this.spritepopup.gety() + 140);
			this.spritebutton.draw(screen);
			
			textArial15.drawtext("Aceptar", screen, this.spritepopup.getx() + 130,this.spritepopup.gety() +  150);

			
			screen.flip(); //Pintamos la pantalla
		
		}
		catch(Exception e){
			
			System.out.println("Error Popup.draw " + e);

		}
	}
	public void keyboard() throws InvalidMidiDataException, IOException, MidiUnavailableException, SDLException {
		
		int sym = 0;
		char key = ' ';
		event.setEvent();
		
		if (event.isPressed()){
				
			sym = event.getSym();
			
			switch (sym){
			
				case 13: //enter
					
					this.usernamepass++;
					if(this.usernamepass>= 3){
						
						if (this.login()){
							this.end = true;
							
						}
						else{
							this.usernamepass = 1;
						}
					}
					keyboard.waitrelease();
				
					break;
				case 27 : //esc
			
					break;
					
		    	case 8: //backspace
		    		
		    		if (username.length()>0){ //backspace
						
						if (this.usernamepass ==1){
							username = (String) username.subSequence(0, username.length() - 1);
						}
						else{
							userpass = (String) userpass.subSequence(0, userpass.length() - 1);
						}
		    
		    		}
		    		break;
		    	case 303: //shift izquierdo
		    	case 304: //shift derecho
		    	
			    	event.setShift(true);
		    		
		    		break;
				default:
					   
					if (event.isShift() ){
						key = (char) (sym -32);
						
					}
					else {
						key = (char)sym;
					}
				
					if (this.usernamepass ==1){
						username = username + key;
					}
					else{
						userpass = userpass + key;
					}
					
		    		break;
	    	
			} //end switch
			
		}
		else if (event.isReleased()){
			
			sym = event.getSym();
			
			switch(sym){
				case 303:
		    	case 304:
		    		
			    	event.setShift(false);
		    		
		    		break;
			}
		}
	    	
	}
	public void set(String title,String message){
		this.title = title;
		
	}

	public boolean login(){
		String pass;
		boolean login = false;

        TableUsers user = new TableUsers();
    	System.out.println("numberusers "+dbusers.getNumberUsers());
	
		System.out.println("nombre login: "+this.username);
		System.out.println("pass   login: "+this.userpass);
		System.out.println("usernamepass: "+this.usernamepass);
		user = dbusers.getUser(username);
		System.out.println();
		
		try{
			pass = TableUsers.getHash(this.userpass);
			if (user.getPass().equalsIgnoreCase(pass)  ){
				
				System.out.println("contrasena correcta");
				login = true;
				
				User.setUser(user);
			}
		}
		catch(Exception e){
			System.out.println("error Login.login "+e);
		}
		return login;
		
	}

	public int go (SDLSurface screen){
		
		this.spritepopup.setx(200);
		this.spritepopup.sety(200);
		this.spritepopup.animate(screen);
		
		while(!this.end){
			
			try{
				this.draw(screen);
				this.keyboard();
				
				if (keyboard.isClicked(spritebutton)){
				
					this.end = this.login();
					
				}
			
			}
			
			catch(Exception e){

			}
		}

		System.out.println("opcion pulsada " +this.option);
		return this.option ;
	}

}
