
import sdljava.SDLException;
import sdljava.ttf.SDLTrueTypeFont;

import sdljava.video.SDLColor;
import sdljava.video.SDLRect;
import sdljava.video.SDLSurface;

public class Text {

	private static SDLSurface ttext;		//creamos variable para mostrar texto

	private SDLColor fgcolor; 	//crea objects para el color de las fonts del texto

	private SDLTrueTypeFont font; 		//almacena el tipo de font

	public Text() {
		
		fgcolor = new SDLColor();
		
		fgcolor.setRed(255);		//establecemos colores de primer plano
		fgcolor.setGreen(255);
		fgcolor.setBlue(255);
	
		
	}

	public void init(String name, int z) {
	
	
		try{
			font = sdljava.ttf.SDLTTF.openFont( name, z);//TTF_OpenFont(name,20); //cargamos la font
			}
			catch(Exception e){
				
				System.out.println("Error text.init(string,int) "+e);
			}
		
	}
	public void init(String name) {
		
		//System.out.println("init1");
		
		//System.out.println("init1.1");
		
		//System.out.println("init1.2");
		

		fgcolor = new SDLColor();
		
		fgcolor.setRed(255);		//establecemos colores de primer plano
		fgcolor.setGreen(255);
		fgcolor.setBlue(255);

		try{
		font = sdljava.ttf.SDLTTF.openFont( name, 20);//TTF_OpenFont(name,20); //cargamos la font
		}
		catch(Exception e){
			
			System.out.println("Error text.init(string) "+e);
		}
	}

	
	void setcolor(int r,int g, int b){
		
		fgcolor.setBlue(b);
		fgcolor.setRed(r);
		fgcolor.setGreen(g);
	}

	void drawtext(String msg,SDLSurface screen,double x, double y) throws SDLException{

		try{
			ttext = font.renderTextBlended(msg,  fgcolor);//sdljava.ttf.SDLTrueTypeFont.renderTextShaded(msg, fgcolor, bgcolor);
	
			SDLRect textpos = new SDLRect(0, 0);
			textpos.x = (int) x;
			textpos.y = (int) y;
	
			ttext.blitSurface(screen, textpos);
		
		}
		catch(Exception e){
			System.out.println("error Text.drawtext "+e);
		}
	}


}
